
# q-expansion of newform 588.2.a.f, downloaded from the LMFDB on 17 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 588
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[0], [1], [2], [0], [2], [3], [-8], [1], [8], [4], [-3], [-1], [-6], [11], [-6], [-12], [-4], [6], [13], [-10], [11], [-3], [-2], [0], [-10], [-10], [-11], [0], [-11], [-14], [3], [2], [4], [5], [-12], [-8], [-2], [-4], [2], [-16], [6], [15], [6], [11], [8], [-8], [-4], [-8], [18], [-1], [14], [18], [-14], [0], [-18], [12], [2], [24], [17], [20], [-19], [24], [23], [2], [17], [-24], [17], [21], [24], [14], [6], [-20], [-5], [-5], [13], [28], [10], [-3], [-12], [19], [-18], [-27], [-30], [25], [-24], [-4], [22], [13], [-4], [-11], [-34], [28], [-19], [-36], [-29], [30], [-18], [36], [31], [-15], [-12], [22], [46], [6], [-21], [41], [-32], [6], [-12], [1], [3], [-30], [26], [11], [-16], [-40], [-35], [-6], [-6], [-28], [29], [-1], [-12], [36], [43], [-8], [14], [6], [23], [-45], [-9], [-18], [15], [42], [-8], [-31], [-22], [-24], [48], [22], [32], [2], [40], [54], [11], [4], [-23], [0], [-8], [46], [-38], [-48], [29], [6], [21], [48], [-11], [-6], [49], [-52], [10], [-28], [-31], [-36], [-18], [12], [11], [1]]
